/*
 *	filebrowser.h
 *
 *	The File Browser allows easy file browsing.
 *
 *	(C) Copyright 1998, Pierre ARNAUD, OPaC bright ideas
 *		CH-1437 SUSCEVAZ, Switzerland. All rights reserved.
 */

/******************************************************************************

  This file is part of the OPaC class library ("OPaC").

  OPaC is distributed with NO WARRANTY OF ANY KIND.  No author or distributor
  accepts any responsibility for the consequences of using it, or for whether
  it serves any particular purpose or works at all, unless he or she says so
  in writing. Refer to the OPaC Free Public License (the "License") for full
  details.

  Every copy of OPaC must include a copy of the License, normally in a plain
  ASCII text file named PUBLIC. The License grants you the right to copy,
  modify and redistribute OPaC, but only under certain conditions described
  in the License. The copyright notice and this notice must be preserved on
  all copies.

******************************************************************************/

#ifndef _OPaC_FILEBROWSER_H_
#define	_OPaC_FILEBROWSER_H_

#ifndef	_OPaC_OBJECTPANE_H_
#include <OPaC/objectpane.h>
#endif

/****************************************************************/

class OP_PUBLIC OPFileBrowser : public OPObject
{
protected:
	OPStringRef			path;					//	path to directory
	OPDataBaseRef		db;						//	data base
	OPEntityModelRef	db_model;				//	data base model
	OPDBProviderRef		provider;				//	data base provider

protected:
	OPFileBrowser ();
	virtual ~ OPFileBrowser ();
	
	virtual void StoreInstance (OPStorageIn storage);	/* OVERRIDDEN */
	virtual void RestoreInstance (OPStorageIn storage);	/* OVERRIDDEN */
	
public:
	virtual void Initialise (OPStringIn path);
	virtual void Update ();
	
	virtual const OPDBProviderRef& ReturnProvider () const;
	
	OP_DEFINE_CLASS (OPFileBrowser, OPObject);
};

/****************************************************************/

#endif /* _OPaC_FILEBROWSER_H_ */
