/*
 *	gridview.h
 *
 *	This view is a special one, since it does only draw overlays.
 *
 *	(C) Copyright 1998, Pierre ARNAUD, OPaC bright ideas
 *		CH-1437 SUSCEVAZ, Switzerland. All rights reserved.
 */

/******************************************************************************

  This file is part of the OPaC class library ("OPaC").

  OPaC is distributed with NO WARRANTY OF ANY KIND.  No author or distributor
  accepts any responsibility for the consequences of using it, or for whether
  it serves any particular purpose or works at all, unless he or she says so
  in writing. Refer to the OPaC Free Public License (the "License") for full
  details.

  Every copy of OPaC must include a copy of the License, normally in a plain
  ASCII text file named PUBLIC. The License grants you the right to copy,
  modify and redistribute OPaC, but only under certain conditions described
  in the License. The copyright notice and this notice must be preserved on
  all copies.

******************************************************************************/

#ifndef _OPaC_GRIDVIEW_H_
#define _OPaC_GRIDVIEW_H_

#include <OPaC/view.h>

/****************************************************************/

/*
 *	The grid view draws a grid above/below the window.
 */

class OP_PUBLIC OPGridView : public OPView
{
protected:
	OPCoord				dx;
	OPCoord				dy;
	
protected:
	OPGridView ();
	virtual ~ OPGridView ();

public:
	virtual void SetGridPitch (OPCoord dx, OPCoord dy);
	virtual void GetGridPitch (OPCoordOut dx, OPCoordOut dy) const;

	virtual void AlignOnGrid (OPCoordInOut x, OPCoordInOut y) const;
	
	virtual void DrawOverlay (OPGrailPortIn port, OPRectIn rect); /* OVERRIDDEN */
	virtual void Draw (OPGrailPortIn, OPRectIn, OPDrawOp = OP_DRAW_ALL); /* OVERRIDDEN */
	
	APP_DEFINE_CLASS (OPGridView, OPView);
};

/****************************************************************/

#endif /* _OPaC_GRIDVIEW_H_ */

