/*
 *	opacirt.cxx
 *
 *	Implements some run-time information classes.
 *
 *	(C) Copyright 1994-1998, Pierre ARNAUD, OPaC bright ideas
 *		CH-1437 SUSCEVAZ, Switzerland. All rights reserved.
 */

/******************************************************************************

  This file is part of the OPaC class library ("OPaC").

  OPaC is distributed with NO WARRANTY OF ANY KIND.  No author or distributor
  accepts any responsibility for the consequences of using it, or for whether
  it serves any particular purpose or works at all, unless he or she says so
  in writing. Refer to the OPaC Free Public License (the "License") for full
  details.

  Every copy of OPaC must include a copy of the License, normally in a plain
  ASCII text file named PUBLIC. The License grants you the right to copy,
  modify and redistribute OPaC, but only under certain conditions described
  in the License. The copyright notice and this notice must be preserved on
  all copies.

******************************************************************************/

#include <OPaC/new.h>
#include <OPaC/opacirt.h>
#include <OPaC/typeinfo.h>

#include <string.h>

OP_IMPLEMENTATION (opacirt.h);

/****************************************************************/

/*
 *	Initialise the name of the target. The name we have recorded
 *	might be of style "Method (arg)", so we have to extract just
 *	the "Method" part.
 */

void
OPaC_Target::Initialise ()
{
	char  buffer[50];
	char* ptr = buffer;
	nstrcpy (buffer, this->target_method->method, sizeof (buffer));
	
	while (ptr[0] && (ptr[0] != ' ') && (ptr[0] != '\t') && (ptr[0] != '(')) ptr++;
	ptr[0] = 0;
	this->name = buffer;
	
	Count num   = this->target_method->num_param;
	Count index = 0;
	OPaC_ParamDesc* desc = & this->target_method->param[0];
	
	while (num--) {
		
		desc->name_atomic = desc->name;
		desc->type_def    = 0;
		
		OPTypeInfo::FindType (desc->type, desc->type_def);
		
		desc++;
		index++;
	}
}

/****************************************************************/
